#!/usr/bin/ruby

require "numru/netcdf"
require "numru/dcl"
require "numru/colorbar"

include NumRu

varname = 'Exner'
longname = 'Exner'

#filename = ARGV[0]
filename = "../../nc/arare_dim_ss-t05-n50.nc"
file = NetCDF.open(filename)
var = file.var(varname)
array = var.get

vardim = var.ndims

print vardim

file.close

if ARGV.index("-ps") then
  DCL::gropn(2)
else
  DCL::gropn(4)
end

xmin = 2000.0
xmax = 10000.0
ymin = 0.0
ymax = 10000.0

vxmin = 0.2
vxmax = 0.8
vymin = 0.2
vymax = 0.8

#pmin = 1.000
#pmax = 1.008
#delta = (pmax - pmin) / 10.0
#delta = 2.0

#for k in 1..10
#  tlev1 = pmin + (k-1)*delta
#  tlev2 = tlev1 + delta
#  ipat = (23+7*k)*1000 + 999
#  DCL::uestlv(tlev1,tlev2,ipat)
#end

DCL::grfrm
DCL::grswnd(xmin,xmax,ymin,ymax)
DCL::grsvpt(vxmin,vxmax,vymin,vymax)
DCL::uspfit
DCL::grstrf
DCL::uelset("ltone",true)
DCL::uetone(array)
DCL::usdaxs
DCL::udcntr(array)
DCL::uxsttl('T', longname, 0)

DCL::Util::color_bar

DCL::grcls

=begin

#--- 顼С 

colorbar = 1
if colorbar == 1

  pi = NArray.sfloat(2, 11)

  DCL::grswnd(0.0, 1.0, pmin, pmax)
  DCL::grsvpt(0.85, 0.88, 0.2, 0.8)
  DCL::grstrn(1)
  DCL::grstrf

  for k in 0..10
    pi[0,k] = pmin + k*delta
    pi[1,k] = pmin + k*delta
  end

  DCL::uetone(pi)

  DCL::slpvpr(3)
  DCL::uzlset('LABELYR', true)

  DCL::uzfact(0.9)
  DCL::uysfmt('(F5.1)')
#  DCL::uyaxdv('R', delta, delta)

end

#--------------

DCL::grcls

=end